
import sha1 from 'sha1';

import { dateAndRandomString } from './common'
export default {
    sign(data) {
        //参数加签逻辑
        var timestamp = Date.now();
        var nonceStr = dateAndRandomString(10) ;
        var signStr = this.getSignStr(data);
        if (signStr) {
            signStr = signStr + '&' + 'timestamp=' + timestamp + '&nonceStr=' + nonceStr;
        } else {
            signStr = 'timestamp=' + timestamp + '&nonceStr=' + nonceStr;
        }
        signStr = sha1(signStr);
        return { timestamp: timestamp, nonceStr: nonceStr, signature: signStr };
    },

    getSignStr(data) {
        var args;
        if (data) {
            try {
                if (typeof data == 'object') {
                    data = JSON.stringify(data);
                }
                if (typeof data == 'string') {
                    if (data.indexOf('{') == 0) {
                        args = JSON.parse(data)
                    } else if (data.indexOf('[') == 0) {
                        args = { "": JSON.parse(data) }
                    } else {
                        args = { "": data }
                    }
                }
            } catch (err) {
                args = { "": data }
            }
        }
        var attr = [];
        if (args) {
            var keys = Object.keys(args);
            keys.sort();
            if (keys.length > 1) {
                //按字符排序后将第一个变量放入最后一个
                var firstKey = keys.shift();
                keys.push(firstKey);
            }
            for (const key of keys) {
                var val = args[key];
                if (typeof val == 'object') {//如果是object类型，需要转json字符串处理，否则可能和后端不一致导致验签失败
                    if (key) {
                        val = this.getSignStr(val);
                        if (val.indexOf('=') == 0) {
                            val = val.replace('=', '');
                        }
                    }
                    else {
                        val = JSON.stringify(val);
                    }
                }
                attr.push(key + '=' + val)
            }
        }
        var signStr = '';
        if (attr.length > 0) {
            signStr = attr.join('&');
        }
        return signStr;
    }
};