// 时间戳转时间
function toDate(value) {
  if (value) {
    var date = new Date(value);
    var y = date.getFullYear();
    var m = date.getMonth() + 1;
    m = m < 10 ? ('0' + m) : m;
    var d = date.getDate();
    d = d < 10 ? ('0' + d) : d;
    var h = date.getHours();
    h = h < 10 ? ('0' + h) : h;
    var minute = date.getMinutes();
    var second = date.getSeconds();
    minute = minute < 10 ? ('0' + minute) : minute;
    second = second < 10 ? ('0' + second) : second;
    return y + '-' + m + '-' + d + ' ' + h + ':' + minute + ':' + second;
  } else {
    return ""
  }
}

// 删除单引号
function delMarks(data) {
  if (!data || data.length == 0) {
    return data;
  }
  if (data.indexOf("'") == 0 && data.lastIndexOf("'") == data.length - 1) {
    return data.substring(1, data.length - 1);
  } else {
    return data
  }
}

// 随机字符串
function randomString(len) {
  len = len || 5;
  var $chars = 'ABCDEFGHJKMNPQRSTWXYZabcdefhijkmnprstwxyz2345678'; /****默认去掉了容易混淆的字符oOLl,9gq,Vv,Uu,I1****/
  var maxPos = $chars.length;
  var pwd = '';
  for (var i = 0; i < len; i++) {
    pwd += $chars.charAt(Math.floor(Math.random() * maxPos));
  }
  return pwd;
}
//生成区间内的随机数
function randomNumBoth(Min, Max) {
  Min = Min - 0;
  Max = Max - 0;
  var Range = Max - Min;
  var Rand = Math.random();
  var num = Min + Math.round(Rand * Range); //四舍五入
  return num;
}
// 带时间戳随机字符串
function dateAndRandomString(len) {
  return new Date().valueOf() + randomString(len);
}

// url文件下载
function downloadUrl(url, fileName) {
  var request = new XMLHttpRequest();
  request.responseType = "blob";
  request.open("GET", url);
  request.onload = function () {
    downloadBlob(this.response, fileName);
  }
  request.send();
}
// blob文件下载
function downloadBlob(blob, fileName) {
  let elt = document.createElement("a");
  let href = window.URL.createObjectURL(blob);
  elt.setAttribute("href", href);
  elt.setAttribute("download", fileName);
  elt.style.display = "none";
  document.body.appendChild(elt);
  elt.click();
  document.body.removeChild(elt);
}
// 下载json
function downloadJson(json, fileName) {
  let elt = document.createElement("a");
  let href = "data:text/json;charset=utf-8," + encodeURIComponent(JSON.stringify(json));
  elt.setAttribute("href", href);
  elt.setAttribute("download", fileName);
  elt.style.display = "none";
  document.body.appendChild(elt);
  elt.click();
  document.body.removeChild(elt);
}

//获取cookie
function getCookie(name) {
  var arr, reg = new RegExp("(^| )" + name + "=([^;]*)(;|$)");
  if (arr = document.cookie.match(reg))
    return unescape(arr[2]);
  else
    return null;
}

// rgba转16进制
function hexify(color) {
  var values = color
    .replace(/rgba?\(/, '')
    .replace(/\)/, '')
    .replace(/[\s+]/g, '')
    .split(',');
  var a = parseFloat(values[3] || 1),
    r = Math.floor(a * parseInt(values[0]) + (1 - a) * 255),
    g = Math.floor(a * parseInt(values[1]) + (1 - a) * 255),
    b = Math.floor(a * parseInt(values[2]) + (1 - a) * 255);
  return "#" +
    ("0" + r.toString(16)).slice(-2) +
    ("0" + g.toString(16)).slice(-2) +
    ("0" + b.toString(16)).slice(-2);
}

// 计算模板字符串
function evalTemplateString(data, key) {
  if (!key) {
    return '';
  }
  var evalExp = /^`[\s\S]*`$/g;
  if (!evalExp.test(key)) {
    key = '`' + key + '`';
  }
  return handleTemplateFun(data, key);
}

// html转义与反转义
function HTMLEncode(html) {
  var temp = document.createElement("div");
  (temp.textContent != null) ? (temp.textContent = html) : (temp.innerText = html);
  var output = temp.innerHTML;
  temp = null;
  return output;
}

function HTMLDecode(text) {
  var temp = document.createElement("div");
  temp.innerHTML = text;
  var output = temp.innerText || temp.textContent;
  temp = null;
  return output;
}

// 滚动监听
function scrollListener(element, fun) {
  const div = element;
  const load = fun;
  let listener;
  let interval;
  let resize;
  let offset = 50;
  scrollFun();
  window.addEventListener('resize', resize = () => {
    scrollFun();
  })

  function clear() {
    if (listener) {
      $(div).off('scroll', listener);
    }
    if (interval) {
      clearInterval(interval);
      interval = undefined;
    }
    if (resize) {
      window.removeEventListener('resize', resize);
    }
  }

  function scrollFun() {
    var height = $(div).height();
    var childHeight = $(div).children().height();
    var scrollTop = $(div).scrollTop();
    if (!div || $(div).length == 0) {
      clear();
      return;
    }
    if (height > childHeight - offset) {
      // 内容未撑满
      load();
      if (!interval) {
        // 没有定时器设置定时器
        interval = setInterval(() => {
          scrollFun();
        }, 1000);
      }
    } else {
      // 内容已撑满
      if (interval) {
        // 包含定时器去除定时器
        clearInterval(interval);
        interval = undefined;
      }
      if (height + scrollTop > childHeight - offset) {
        // 内容滚动至偏移量位置
        load();
      }
      if (!listener) {
        // 没有滚动监听设置滚动监听
        $(div).on('scroll', listener = () => {
          scrollFun();
        })
      }
    }
  }
  return {
    clear,
  }
}

// 判断终端
function os() {
  let ua = navigator.userAgent,
    ual = ua.toLowerCase(),
    isWindowsPhone = /(?:Windows Phone)/.test(ua),
    isSymbian = /(?:SymbianOS)/.test(ua) || isWindowsPhone,
    isAndroid = /(?:Android)/.test(ua),
    isFireFox = /(?:Firefox)/.test(ua),
    isChrome = /(?:Chrome|CriOS)/.test(ua),
    isTablet = /(?:iPad|PlayBook)/.test(ua) || (isAndroid && !/(?:Mobile)/.test(ua)) || (isFireFox && /(?:Tablet)/.test(ua)),
    isPhone = /(?:iPhone)/.test(ua) && !isTablet,
    isPc = !isPhone && !isAndroid && !isSymbian,
    isWeixin = ual.indexOf('micromessenger') != -1;
  return {
    isTablet,
    isPhone,
    isAndroid,
    isPc,
    isWeixin,
  };
}

// 处理html模板
function handHtmlPlaceholder(origin, data) {
  if (!origin) {
    return '';
  }
  var evalExp = /\[\[[^\[\]<>]+\]\]/g;
  var list = origin.match(evalExp) || [];
  for (var i = 0; i < list.length; i++) {
    var placeholder = list[i].slice(2, list[i].length - 2);
    var temp = '';
    try {
      temp = handleTemplateFun(data, placeholder) || '';
    } catch (error) { }
    origin = origin.replace(list[i], temp);
  }
  return origin;
}

function handleTemplateFun(data, template) {
  var text = '';
  for (var i in data) {
    if (i) {
      var temp = JSON.stringify(data[i]);
      text += `var ${i}=${temp};`;
    }
  }
  return eval(`(function(){${text}return ${template}})()`);
}
// 处理筛选条件无值
function mapDealObject(obj) {
  for (let key in obj) {
    if (obj[key].length == 0) {
      return true
    } else {
      if (Array.isArray(obj[key])) {
        for (let i = 0; i < obj[key].length; i++) {
          return mapDealObject(obj[key][i])
        }
      }
    }
  }
}
export {
  toDate,
  delMarks,
  randomString,
  dateAndRandomString,
  downloadUrl,
  downloadBlob,
  downloadJson,
  getCookie,
  hexify,
  evalTemplateString,
  HTMLEncode,
  HTMLDecode,
  scrollListener,
  os,
  handHtmlPlaceholder,
  handleTemplateFun,
  mapDealObject,
  randomNumBoth,
}
